﻿// JScript File for WESNet.WebControls.ExtendedCheckBoxList Custom WebServer Control (ASP.NET 2.0)

// Written By William Severance, WESNetDesigns
// Date Last Modified: April 20, 2006

// Website: http://www.wesnetdesigns.com
// E-Mail: imagemaker@wesnetdesigns.com

// Disclaimer: This software is provided without charge "AS IS" with no warranties of any kind. The entire risk
// arising out of the use or performance of the software is with you.
        
function ExtendedCheckBoxList_Click (checkbox) {
    if (checkbox == null) return void(0);
    
    var parentlist = getParentList(checkbox);
    if (parentlist == null) return void(0);
    
    var checkboxes = getCheckboxes(parentlist);
    if (checkboxes == null) return void(0);
    
    var checked = checkbox.checked;
    
    var maxchecks = 999;
    if (parentlist.getAttribute("maxchecks") != null) {
          maxchecks=parseInt(parentlist.getAttribute("maxchecks"));
    }
    
    var maxcheckserrormessage = "";
    if (parentlist.getAttribute("maxcheckserrormessage") != null) {
          maxcheckserrormessage = parentlist.getAttribute("maxcheckserrormessage");
    }
    
    var alltext = "all"
    if (parentlist.getAttribute("alltext") != null) {
          alltext = parentlist.getAttribute("alltext").toLowerCase();
    }
    
    var nonetext = "none"
    if (parentlist.getAttribute("nonetext") != null) {
          nonetext = parentlist.getAttribute("nonetext").toLowerCase();
    }
    
    var groupname = ""
    if (parentlist.getAttribute("groupname") !=null) {
          groupname=parentlist.getAttribute("groupname")
    }
    
    var allcheckbox = getAllCheckbox(checkboxes, alltext)
    var nonecheckbox = getNoneCheckbox(checkboxes, nonetext)
    
    switch (getText(checkbox)) {
       case alltext:
         if (checked) {
           setAllCheckboxes (checkboxes, nonetext);
         }
         break;
       case nonetext:
         if (checked) {
           clearAllCheckboxes(checkboxes, nonetext);
         }
         break;
       default:
         if (checked && (countChecks(checkboxes)> maxchecks)) {
                checkbox.checked=false;
                if (maxcheckserrormessage.length>0) {
                   alert (maxcheckserrormessage);
                }
                return;
         }
         setCheck(allcheckbox, AllChecked(checkboxes, alltext, nonetext));
         setCheck(nonecheckbox,NoneChecked(checkboxes, alltext, nonetext));   
   }
   
   var groups = getGroups(groupname);
   
   if (checked && (checkbox != nonecheckbox) && (groups.length>1)) {
      var value = false;
      if (checkbox == allcheckbox) {
            checkbox=nonecheckbox;
            value = true;
      }
      for (i=0; i<groups.length; i++) {
        if (groups[i] != parentlist) {
           
           var checkbox2id = groups[i].id + "_" + getCheckboxNumber(checkbox);
           var checkbox2 = null;
           if (document.getElementById) {
               checkbox2 = document.getElementById(checkbox2id);
           }
           else {
               checkbox2 = document.all[checkbox2id];
           }
           if (checkbox2 != null) {
              checkbox2.checked=value;
              ExtendedCheckBoxList_Click (checkbox2);
           }
       }
    }
  }
}

function getParentList (checkbox) {
    if (document.getElementById) {
        return document.getElementById(getListId(checkbox));
    }
    else {
        return document.all[getListId(checkbox)];
    }
}

function getListId (checkbox) {
    var lastunderscore = checkbox.id.lastIndexOf("_");
    if (lastunderscore > 0) {
      return checkbox.id.substring(0, lastunderscore);
    }
    else {
      return checkbox.parentNode.id;
    }
}

function getCheckboxNumber (checkbox) {
    var lastunderscore = checkbox.id.lastIndexOf ("_");
    if (lastunderscore > 0) {
       return checkbox.id.substring(lastunderscore+1);
    }
    else {
      return checkbox.id;
    }
}

function setAllCheckboxes (checkboxes, nonetext) {
   for (var i=0; i < checkboxes.length; i++) {
     var cb = checkboxes[i];
     var text = getText(cb);
     cb.checked = (text != nonetext);
   }
   return void(0);
}

function clearAllCheckboxes (checkboxes, nonetext) {
   for (var i=0; i < checkboxes.length; i++) {
     var cb = checkboxes [i];
     var text = getText(cb);
     cb.checked = (text == nonetext);
   }
  return void(0);
}

function getCheckboxes (parentlist) {
   var checkboxes = new Array();
   if (parentlist != null) {
     var cnt = 0;
     var children = parentlist.getElementsByTagName("input");
     for (var i=0; i<children.length; i++) {
       cb = children [i];
       if (cb.type == "checkbox") {
          checkboxes[cnt] = cb;
          cnt++;
       }
     }
   }
   return checkboxes;
}

function getAllCheckbox (checkboxes, alltext) {
   if (checkboxes == null) return null;
   for (var i=0;i<checkboxes.length; i++) {
     var cb = checkboxes [i];
     var text = getText(cb);
     if (text == alltext) {
           return cb;
     }
   }
   return null;
}

function getNoneCheckbox (checkboxes, nonetext) {
   if (checkboxes == null) return null;
   for (var i=0;i<checkboxes.length; i++) {
     var cb = checkboxes [i];
     var text = getText(cb);
     if (text == nonetext) {
           return cb;
        }
   }
   return null;
}

function setCheck (checkbox, checked) {
  if (checkbox != null) {
    checkbox.checked = checked;
  }
  return void(0);
}

function AllChecked (checkboxes, alltext, nonetext) {
   var cnttotal = 0;
   var cntchecked = 0;
   if ((checkboxes != null) && (checkboxes.length > 0)) {
      for (var i=0; i<checkboxes.length; i++) {
         var cb = checkboxes [i];
         var text = getText(cb);
         if ((text != alltext) && (text != nonetext)) {
            cnttotal++;
            if (cb.checked) {
              cntchecked++;
            }
         }
      }
   }
   return (cntchecked == cnttotal);
}

function NoneChecked (checkboxes, alltext, nonetext) {
   var cntchecked = 0;
   if ((checkboxes != null) && (checkboxes.length > 0)) {
      for (var i=0; i<checkboxes.length; i++) {
         var cb = checkboxes [i];
         var text = getText(cb);
         if ((text != alltext) && (text != nonetext)) {
              if (cb.checked) {
              cntchecked++;
            }
         }
      }
   }
   return (cntchecked == 0);
}

function countChecks (checkboxes, alltext, nonetext) {
  var cntchecked = 0
  if ((checkboxes!=null) & (checkboxes.length > 0)) {
     for (var i=0; i<checkboxes.length; i++) {
         var cb = checkboxes [i];
         var text = getText(cb);
         if ((text != alltext) && (text != nonetext)) {
              if (cb.checked) {
              cntchecked++;
            }
         }
      }
   }
   return cntchecked;
}

function getIDs(checkboxes) {
   var s = "";
   for (var i=0; i<checkboxes.length; i++) {
     s += (checkboxes[i].id + "\n");
   }
   return s;
}

function getText (checkbox) {
  var label = checkbox.nextSibling;
    if ((label != null) && (label.tagName.toLowerCase() == "label")) {
      return label.innerText.toLowerCase();
      }
    else {
      return "";
    }
}

function getGroups (groupname) {
    var groups = new Array();
    if ((groupname != null) && (groupname.length>0)){
        var tagnames = new Array("span","table");
        for (var i=0;i<tagnames.length;i++) {
            var elements = document.getElementsByTagName(tagnames[i]);
            for (var j=0;j<elements.length;j++) {
                var element = elements[j];
                var attribute = element.getAttribute("groupname");
                if ((attribute != null) && (attribute == groupname)) {
                    groups.push(element);
                }
            }
        }  
    }
    return groups;
}
    
       
   
   
        
        



